%define pkvm_version 3.4.4.0
%define pkvm_release 31
%define pkvm_respin .0

Name:           ibm-powerkvm-config
Version:        %{pkvm_version}
Release:        %{pkvm_release}%{?pkvm_respin}%{?dist}
Summary:        RHEV for IBM Power Configuration
Group:          System Environment/Base
License:        EPL
URL:            http://www.ibm.com
Obsoletes:      powerkvm-installer
Requires:       systemd
Requires:       libvirt
Requires:       libvirt-daemon-driver-network
Requires:       qemu-common
Requires:       util-linux
Source0:        README.txt
Source1001:     89-hw_random.rules
Source1002:     kop-smt.service
Source1003:     kop.xml
Source1004:     disableSMT.sh
Source1005:     network
Source1006:     multipath.conf

%description
RHEV for IBM Power Configuration

%prep
%{__cp} %{SOURCE0} %{_builddir}
%{__cp} %{SOURCE1001} %{_builddir}
%{__cp} %{SOURCE1002} %{_builddir}
%{__cp} %{SOURCE1003} %{_builddir}
%{__cp} %{SOURCE1004} %{_builddir}
%{__cp} %{SOURCE1005} %{_builddir}
%{__cp} %{SOURCE1006} %{_builddir}

%build

%install
%{__rm} -rf %{buildroot}
%{__mkdir_p} %{buildroot}%{_sysconfdir}/udev/rules.d
%{__install} %{SOURCE1001} %{buildroot}%{_sysconfdir}/udev/rules.d
%{__mkdir_p} %{buildroot}%{_sysconfdir}/systemd/system/multi-user.target.wants
%{__install} %{SOURCE1002} %{buildroot}%{_sysconfdir}/systemd/system/multi-user.target.wants
%{__mkdir_p} %{buildroot}%{_sysconfdir}/libvirt/qemu/networks/autostart
%{__install} %{SOURCE1003} %{buildroot}%{_sysconfdir}/libvirt/qemu/networks
%{__ln_s} ../kop.xml %{buildroot}%{_sysconfdir}/libvirt/qemu/networks/autostart/kop.xml
%{__mkdir_p} %{buildroot}/opt/ibm/powerkvm/scripts
%{__install} %{SOURCE1004} %{buildroot}/opt/ibm/powerkvm/scripts
%{__mkdir_p} %{buildroot}%{_sysconfdir}/sysconfig
%{__install} %{SOURCE1005} %{buildroot}%{_sysconfdir}/sysconfig
%{__install} %{SOURCE1006} %{buildroot}%{_sysconfdir}

%post
if [ $1 -eq 1 ]; then  # install
    if ! grep -q -s "<uuid>" %{_sysconfdir}/libvirt/qemu/networks/kop.xml ; then
        UUID=`/usr/bin/uuidgen`
        %{__sed} -i -e "s,</name>,</name>\n  <uuid>$UUID</uuid>," %{_sysconfdir}/libvirt/qemu/networks/kop.xml
    fi

    if ! grep -q -s "allow virbr1" %{_sysconfdir}/qemu/bridge.conf ; then
        echo "allow virbr1" >> %{_sysconfdir}/qemu/bridge.conf
    fi

    if ! grep -q -s "kernel.printk = 3 4 1 3" %{_sysconfdir}/sysctl.conf ; then
        # Do no print Kernel stuff in output
        echo "kernel.printk = 3 4 1 3" >> /etc/sysctl.conf
    fi
fi
if [ $1 -eq 2 ]; then # update
    if grep -q -s "<forward" %{_sysconfdir}/libvirt/qemu/networks/kop.xml ; then
        ( # edit kop bridge
          %{__rm} -rf /tmp/kop.xml
          virsh net-dumpxml kop > /tmp/kop.xml
          %{__cp} /tmp/kop.xml %{_sysconfdir}/libvirt/qemu/networks/kop.xml.bkp
          %{__sed} -i '/<forward\/>/d' /tmp/kop.xml
          %{__sed} -i '/<forward/,/forward>/d' /tmp/kop.xml
          # stop and undefine kop bridge
          virsh net-destroy kop
          virsh net-undefine kop
          # define, start and auto-start kop bridge
          virsh net-define /tmp/kop.xml
          virsh net-start kop
          virsh net-autostart kop
          # cleanup
          %{__rm} -rf /tmp/kop.xml ) > /dev/null
    fi
fi

%files
%defattr(0644,root,root,-)
%{_sysconfdir}/udev/rules.d/89-hw_random.rules
%{_sysconfdir}/systemd/system/multi-user.target.wants/kop-smt.service
%attr(0755,root,root) /opt/ibm/powerkvm/scripts/disableSMT.sh
%config(noreplace) %{_sysconfdir}/libvirt/qemu/networks/kop.xml
%config(noreplace) %{_sysconfdir}/libvirt/qemu/networks/autostart/kop.xml
%config(noreplace) %{_sysconfdir}/sysconfig/network
%config(noreplace) %{_sysconfdir}/multipath.conf
%doc README.txt

%changelog
* Mon Jul 28 2014 User <gyr@linux.vnet.ibm.com> - 2.1.1.0-4.0
- Added systemd SMT powerkvm service
- Added powerkvm virtual network creation

* Mon Apr 21 2014 User <user@domain> - 2.1.0-1
- Initial version
